Imports System.ComponentModel

Public Class IconButtonBar
    Event ItemClick(ByVal sender As Object, ByVal index As Integer)

    Private WithEvents p_Items As New GenericControlList(Of Field)

    Public ReadOnly Property Items() As GenericControlList(Of Field)
        Get
            If p_Items Is Nothing Then
                p_Items = New GenericControlList(Of Field)
            End If
            Return p_Items
        End Get
    End Property


    Sub ItemClickRaiser(ByVal sender As Object, ByVal e As EventArgs)

        Dim i As Integer = 0 : For Each f As Field In p_Items
            If f.ctrl Is sender Then
                RaiseEvent ItemClick(f, i)
                If f.ContextMenu IsNot Nothing Then
                    f.ContextMenu.Show(Me, New Point(f.ctrl.Left, 0))
                End If

                Exit Sub
            End If
            i += 1
        Next
    End Sub
    Private Sub p_Items_OnAdd(ByVal item As Field) Handles p_Items.OnAdd

        Try

            Dim f As Field = p_Items.Item(p_Items.Count - 1)
            f.ctrl = New IconButton(item.Text, item.Image)
            AddHandler f.ctrl.Click, AddressOf ItemClickRaiser

            p_Items(p_Items.Count - 1) = f

            For i As Integer = Me.Controls.Count - 1 To 0 Step -1
                If TypeOf Me.Controls(i) Is IconButton Then
                    Me.Controls.RemoveAt(i)
                End If
            Next
            Dim right As Integer = -1


            'MsgBox(p_Items.Count)
            For Each i As Field In p_Items
                i.ctrl.Left = right + 1
                Me.Controls.Add(i.ctrl)
                right = Math.Max(right, i.ctrl.Right)
            Next

            '            Me.Controls.Add(item.ctrl)
            '            item.ctrl.Left = right + 1
        Catch ex As Exception
            MsgBox(ex.StackTrace & vbCrLf & " ----" & vbCrLf & ex.Message)
        End Try


        '    Try
        '        Dim btn As New IconButton(item.Text, item.Image)

        '        item.ctrl = btn
        '        Me.Controls.Add(btn)
        '        If p_Items.Count >= 2 Then
        '            With p_Items(p_Items.Count - 2).ctrl
        '                '        btn.Left = .Left + .Width
        '            End With
        '        End If
        '        Arrows()
        '    Catch ex As Exception
        '        MsgBox(ex.StackTrace & vbCrLf & " ----" & vbCrLf & ex.Message)
        '    End Try

    End Sub

    Sub Arrows()
        Dim min, max As Integer
        For Each c As Control In Me.Controls
            If TypeOf c Is IconButton Then
                min = Math.Min(min, c.Left)
                max = Math.Max(max, c.Left + c.Width)
            End If
        Next
        If max > Me.Width Then
            Me.RightArr.Show()
        Else
            Me.RightArr.Hide()
        End If
        If min < 0 Then
            Me.LeftArr.Show()
        Else
            Me.LeftArr.Hide()
        End If


    End Sub

    Private Sub p_Items_OnClear() Handles p_Items.OnClear
        'Me.Controls.Clear()
    End Sub

    'Private Sub p_Items_OnRemove(ByVal item As Field) Handles p_Items.OnRemove
    '    Me.Controls.Remove(item)
    'End Sub

    'Private Sub p_Items_OnRemoveAt(ByVal index As Integer) Handles p_Items.OnRemoveAt
    '    Me.Controls.RemoveAt(index)
    '    If p_Items.Count = 0 Then Return
    '    'else
    '    Dim plus As Short = 0
    '    If index = 0 Then
    '        plus = 1
    '        p_Items(0).Left = 0
    '    End If

    '    For i As Integer = index + plus To p_Items.Count - 1
    '        p_Items(i).Left = p_Items(i - 1).Left + p_Items(i - 1).Width
    '    Next
    'End Sub

    Private Sub Bar_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.Height = 16
        Arrows()

    End Sub

    Private Sub LeftArr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LeftArr.Click
        For Each c As Control In Me.Controls
            If TypeOf c Is IconButton Then
                c.Left += 16
            End If
        Next
        Arrows()
    End Sub

    Private Sub RightArr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RightArr.Click
        For Each c As Control In Me.Controls
            If TypeOf c Is IconButton Then
                c.Left -= 16
            End If
        Next
        Arrows()
    End Sub


    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub
End Class

'Class ButtonArraySerializer
'    Inherits CodeDomSerializer

'End Class